program NkV;

uses Windows, NTypes, NLib, NForm, MainForm, ImgFilter, FileList;

{$R *.RES}

var
  list: TFileList;
  i: Integer;
  loadpos: Boolean;
  stdin: Boolean;
  x, y, w, h: Integer;
  rc: TRect;
  dir: TDir;
begin
  App.Name := 'NkV';
  App.ProfDir := GetEnv('NKTOOLSPROF');
  if App.ProfDir = '' then
    App.ProfDir := DirName(Argv[0])
  else
    App.ProfDir := JoinPath([App.ProfDir, 'nkv']);

  loadpos := FindWindow(PChar(string(TNkVMainForm.ClassName)), nil) = 0;

  list := TFileList.Create;
  App.MainForm := TNkVMainForm.CreateDefaultPos(App.Name, 320, 240);
  with App.MainForm as TNkVMainForm do
    try
      if loadpos then
        LoadFormPos(JoinPath([App.ProfDir, 'position']), App.MainForm);

      LoadConfig;

      for i := 1 to High(Argv) do
        if IsDir(Argv[i]) then
        begin
          DirMode := High(Argv) = 1;
          with TListDir.Create(Argv[i]) do
            try
              while Each(dir) do
                if not (dmDirectory in dir.Mode) then
                  list.Add(ReplaceChar(JoinPath([Argv[i], dir.Name]),'/','\'));
            finally
              Free;
            end
        end else
          list.Add(ReplaceChar(Argv[i], '/', '\'));
      list.Sort;
      stdin := list.Count = 0;
      if stdin then 
        list.Add('');
      LoadFirstFile(list);
      list.Free;

      if not stdin then
        if FileList.Count = 0 then
        begin
          ExitCode := 1;
          Exit;
        end
        else if FileList.Count = 1 then
        begin
          DirMode := True;
          FileListUpdate := True;
        end;
    
      if Image.Loaded then
      begin
        GetBounds(x, y, w, h);
        rc := GetMonitorRectFromPoint(x, y);
        if (x+w) > rc.Right then
          x := rc.Right-w;
        if (y+h) > rc.Bottom then
          y := rc.Bottom-h;
        if x < rc.Left then
          x := rc.Left;
        if y < rc.Top then
          y := rc.Top;
        SetPosition(x, y);
      end;

      Show;
      ExitCode := App.Run;
    finally
      Free;
    end;
end.
